public class LinkedList {
	public Node first;
	public Node last;
	
	// Here variables first and last are declared public.
	// This is a really bad idea since it will expose the
	// internal chain of nodes. Because of that,
	// the users of LinkedList could potentially do 
	// things that will break the logic of the list.
	// This problem is solvable by using packages and
	// protected variables but we don't cover this in the course.

	public LinkedList() {
		first = null;
		last  = null;
	}
	
	public void addFirst(Object o) {
		Node node = new Node();
		node.element = o;
		node.next    = first;
		
		first = node;
		if (last == null)
			last = node;
	}
	
	public void addLast(Object o) {
		Node node = new Node();
		node.element = o;
		node.next    = null;
		
		if (last != null)
			last.next = node;
		last = node;
		if (first == null)
			first = node;
	}
	
	ListIterator iterator() {
		return new ListIterator(this);
	}
}
